---
- name: snmptt
  block:
    - name: delete trapConf
      ansible.builtin.file:
        path: '/etc/snmp/trapConf'
        state: absent

    - name: mkdir /etc/snmp/trapConf
      ansible.builtin.file:
        path: '/etc/snmp/trapConf'
        state: directory

    - name: convert mibs for snmptt
      block:
        - name: find cisco mibs
          ansible.builtin.find:
            path: '/usr/share/snmp/mibs/cisco'
          register: files_remote

        - name: convert cisco mibs
          ansible.builtin.shell:
            cmd: 'snmpttconvertmib --in={{item.path}} --out=/etc/snmp/trapConf/cisco.conf'
          with_items:
            - "{{files_remote['files']}}"

        - name: find iana mibs
          ansible.builtin.find:
            path: '/usr/share/snmp/mibs/iana'
          register: files_remote

        - name: convert iana mibs
          ansible.builtin.shell:
            cmd: 'snmpttconvertmib --in={{item.path}} --out=/etc/snmp/trapConf/iana.conf'
          with_items:
            - "{{files_remote['files']}}"

        - name: find ietf mibs
          ansible.builtin.find:
            path: '/usr/share/snmp/mibs/ietf'
          register: files_remote

        - name: convert ietf mibs
          ansible.builtin.shell:
            cmd: 'snmpttconvertmib --in={{item.path}} --out=/etc/snmp/trapConf/ietf.conf'
          with_items:
            - "{{files_remote['files']}}"

        - name: find std mibs
          ansible.builtin.find:
            path: '/usr/share/snmp/mibs/'
          register: files_remote

        - name: convert std mibs
          ansible.builtin.shell:
            cmd: 'snmpttconvertmib --in={{item.path}} --out=/etc/snmp/trapConf/std.conf'
          with_items:
            - "{{files_remote['files']}}"
      ignore_errors: true

    - name: Configure snmptt.ini - Find config files
      ansible.builtin.find:
        path: '/etc/snmp/trapConf/'
      register: files_remote

    - name: Configure snmptt.ini - Add trapConfigs
      ansible.builtin.lineinfile:
        path: '/etc/snmp/snmptt.ini'
        insertafter: '^snmptt_conf_files = <<END'
        line: '{{ item.path }}'
      with_items:
        - "{{ files_remote['files'] }}"

    - name: Configure snmptt.ini 
      ansible.builtin.lineinfile:
        path: '/etc/snmp/snmptt.ini'
        line: '{{ item.to }}'
        regexp: '{{ item.regex }}'
        state: present
      with_items:
        - { regex: "^dns_enable = .*", to: "dns_enable = 1" }
        - { regex: "^description_mode= .*", to: "description_mode = 0" }
        - { regex: "^DEBUGGING = .*", to: "DEBUGGING = 0" }

    - name: Configure snmptt.ini Logging
      ansible.builtin.lineinfile:
        path: '/etc/snmp/snmptt.ini'
        insertafter: '^\[Logging\]'
        line: '{{ item.to }}'
        regexp: '{{ item.regex }}'
        state: present
      with_items:
        - { regex: "^log_enable = .*", to: "log_enable = 0" }
        - { regex: "^log_system_enable = .*", to: "log_system_enable = 0" }
        - { regex: "^unknown_trap_log_enable = .*", to: "unknown_trap_log_enable = 0" }
        - { regex: "^syslog_enable = .*", to: "syslog_enable = 1" }
        - { regex: "^syslog_remote_dest = .*", to: "syslog_remote_dest = 127.0.0.1" }
        - { regex: "^syslog_facility = .*", to: "syslog_facility = local1" }
        - { regex: "^syslog_level = .*", to: "syslog_level = notice" }
        - { regex: "^syslog_system_enable = .*", to: "syslog_system_enable = 0" }
        - { regex: "^syslog_system_level = .*", to: "syslog_system_level = debug" }

    - name: Persmissions for snmptrapd on /var/spool/snmptt
      ansible.builtin.file:
        path: /var/spool/snmptt 
        mode: 'o+rw'
  notify:
    - restart snmptt
  tags: snmptt
